class OntologyParser
  require 'rexml/document'
  include REXML
  attr_accessor :declaration
  attr_accessor :subclassof
  attr_accessor :filename
  attr_accessor :xmldoc
  def get_declarations
    self.declaration=[]
    self.xmldoc.elements.each('Ontology/Declaration/Class') do |declaration|
      self.declaration<<declaration.attributes['IRI']
    end
  end

  def recursively_get_tree(semi_root_hash_lis, subclassof_hash)
    if semi_root_hash_lis.nil?
      return;
    end
    for i in 0...semi_root_hash_lis.size
      if !subclassof_hash[semi_root_hash_lis[i]['name']].nil?
        semi_root_hash_lis[i]['children']=[]
        subclassof_hash[semi_root_hash_lis[i]['name']].each do |ele|
          semi_root_hash_lis[i]['children']<<{'name'=>ele, 'children'=>"",'parent'=>semi_root_hash_lis[i]['name']}
        end
        self.recursively_get_tree(semi_root_hash_lis[i]['children'],subclassof_hash)
      end
    end
    return semi_root_hash_lis
  end

  def generate_engine(subclassof_hash)
    #below will get {"c"=>[["sitea.com", "c"], ["siteb.com", "c"]], "b"=>[["sitec.com", "b"]]}
    subclassof_hash=subclassof_hash.group_by {|k,v| v}
    #zheng li yi xia
    subclassof_hash.each do |k,v|
      tmp=[]
      v.each do |lis|
        tmp<<lis[0]  #abandon the 2th element
      end
      #make it as {"c"=>["sitea.com", "siteb.com"], "b"=>["sitec.com"]}
      subclassof_hash[k]=tmp
    end
    semi_root_lis=self.find_semi_root()
    semi_root_hash_list=[]
    #make the semi_root as Hash List
    semi_root_lis.each do |ele|
      semi_root_hash_list<<{"name"=>ele, "parent"=>"null", "children"=>""}
    end
    res_without_semi_root=self.recursively_get_tree(semi_root_hash_list,subclassof_hash)
    things={'name'=>'Things','parent'=>'null','children'=>''}
    semi_lis=[]
    res_without_semi_root.each do |ele|
      semi_lis<<ele
    end
    things['children']=semi_lis
    return [things]
  end

  def get_subclassof
    self.subclassof=Hash.new
    list=[]
    self.xmldoc.elements.each('Ontology/SubClassOf/Class') do |subclassof|
      list<<subclassof.attributes['IRI']
    end
    list.each_slice(2).each do |each2|
      self.subclassof[each2[0]]=each2[1]
    end
  end

  def initialize(filename)
    self.filename=filename
    xmlfile=File.open(self.filename)
    self.xmldoc=Document.new(xmlfile)
  end

  def find_semi_root
    self.declaration-self.subclassof.keys
  end

  def get_tree
    self.get_declarations
    self.get_subclassof
    require 'json'
    return JSON.generate(self.generate_engine(self.subclassof))
  end
end